; #########################################################################
;
;              Dialog to test complex number functions 
;            Written with MASM32 by Raymond Filiatreault
;                         February 15, 2005
;
; #########################################################################

      .686                   ; processor needed for fcomip instruction
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\zlib.inc
      include \masm32\include\fpu.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\comctl32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\zlib.lib
      includelib \masm32\lib\fpu.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\comctl32.lib

; #########################################################################

      return MACRO arg
          mov eax, arg
          ret
      ENDM

      Z_NUM STRUCT
            real  TBYTE ?
            imag  TBYTE ?
      Z_NUM ENDS

      WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
    
; #########################################################################

.data
      hDlg        dd    0
      hInstance   dd    0
      funcnum     dd    302
      funcproc    dd    ZAdd,ZSub,ZMul,ZDiv,ZPower,ZRoot
                  dd    ZPtoC,ZCtoP,ZRecip,ZSqrt,ZAbs,ZConj,ZExp,ZLn
                  dd    ZSin,ZCos,ZTan,ZCot,ZSec,ZCsc
                  dd    ZAsin,ZAcos,ZAtan,ZAcot,ZAsec,ZAcsc
                  dd    ZSinh,ZCosh,ZTanh,ZCoth,ZSech,ZCsch
                  dd    ZAsinh,ZAcosh,ZAtanh,ZAcoth,ZAsech,ZAcsch

      src1        Z_NUM <>
      src2        Z_NUM <>
      results     Z_NUM <>

      polar       db    0     ;0=cartesian, 1=polar
      sources     db    0     ;0=src1, 1=result
      szerror     db    "Invalid or missing input",0
      txtbuf      db    32 dup(0)

; #########################################################################

.code

start:

    invoke GetModuleHandle, NULL
    mov    hInstance, eax
    invoke InitCommonControls
      
    invoke DialogBoxParam,hInstance,300,NULL,ADDR WndProc,NULL

    invoke ExitProcess,eax

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    .if uMsg == WM_INITDIALOG
        push  hWin
        pop   hDlg
        invoke CheckRadioButton,hWin,302,339,302
        invoke CheckRadioButton,hWin,352,353,352
        invoke CheckRadioButton,hWin,355,356,355
        invoke SendDlgItemMessage,hWin,341,EM_SETLIMITTEXT,19,0
        invoke SendDlgItemMessage,hWin,342,EM_SETLIMITTEXT,19,0
        invoke SendDlgItemMessage,hWin,344,EM_SETLIMITTEXT,19,0
        invoke SendDlgItemMessage,hWin,345,EM_SETLIMITTEXT,19,0
        invoke SendDlgItemMessage,hWin,347,EM_SETREADONLY,TRUE,0
        invoke SendDlgItemMessage,hWin,348,EM_SETREADONLY,TRUE,0

    .elseif uMsg == WM_COMMAND
        mov   eax,wParam
        mov   ecx,eax
        movzx eax,ax   
        shr   ecx,16
        .if     ecx == BN_CLICKED
            .if   eax < 340             ;functions radio buttons
                mov   funcnum,eax
                .if   eax < 308         ;functions with 2 sources
                    invoke SendDlgItemMessage,hDlg,344,EM_SETREADONLY,0,0
                    invoke SendDlgItemMessage,hDlg,345,EM_SETREADONLY,0,0
                .else                   ;functions with 1 source
                    invoke SendDlgItemMessage,hDlg,344,EM_SETREADONLY,TRUE,0
                    invoke SendDlgItemMessage,hDlg,345,EM_SETREADONLY,TRUE,0
                .endif
            .elseif eax == 352          ;cartesian radio button
                mov   polar,0
            .elseif eax == 353          ;polar radio button
                mov   polar,1
            .elseif eax == 355          ;z1 radio button
                mov   sources,0
            .elseif eax == 356          ;result radio button
                mov   sources,1

            .elseif   eax == 358                  ;QUIT
                invoke  EndDialog,hDlg,0
              
            .elseif eax == 357                    ;COMPUTE
                finit
                .if   sources == 0
                    invoke GetDlgItemText,hDlg,341,ADDR txtbuf,32
                    or    eax,eax
                    jz    inputerr
                    invoke FpuAtoFL,ADDR txtbuf,ADDR src1.real,DEST_MEM
                    or    eax,eax
                    jz    inputerr
                    invoke GetDlgItemText,hDlg,342,ADDR txtbuf,32
                    or    eax,eax
                    jz    inputerr
                    invoke FpuAtoFL,ADDR txtbuf,ADDR src1.imag,DEST_MEM
                    or    eax,eax
                    jz    inputerr
                .else
                    fld   results.real
                    fstp  src1.real
                    fld   results.imag
                    fstp  src1.imag
                .endif

                .if     polar == 1
                    fld     src1.real     ;to check if it is negative 
                    fldz
                    fcomip st,st(1)
                    .if !CARRY?
                        fchs
                        fstp  src1.real
                        fld   src1.imag
                        fldpi
                        fadd
                        fstp  src1.imag
                        .if   sources == 0
                            invoke FpuFLtoA,ADDR src1,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                            invoke SetDlgItemText,hDlg,341,ADDR txtbuf
                            invoke FpuFLtoA,ADDR src1.imag,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                            invoke SetDlgItemText,hDlg,342,ADDR txtbuf
                        .endif
                    .endif
                    finit
                .endif

                .if   funcnum < 308
                    invoke GetDlgItemText,hDlg,344,ADDR txtbuf,32
                    or    eax,eax
                    jz    inputerr
                    invoke FpuAtoFL,ADDR txtbuf,ADDR src2.real,DEST_MEM
                    or    eax,eax
                    jz    inputerr
                    invoke GetDlgItemText,hDlg,345,ADDR txtbuf,32
                    or    eax,eax
                    jz    inputerr
                    invoke FpuAtoFL,ADDR txtbuf,ADDR src2.imag,DEST_MEM
                    or    eax,eax
                    jz    inputerr
                    .if     polar == 1
                        fld     src2.real     ;to check if it is negative
                        fldz
                        fcomip st,st(1) 
                        .if !CARRY?
                            fchs
                            fstp  src2.real
                            fld   src2.imag
                            fldpi
                            fadd
                            fstp  src2.imag
                            invoke FpuFLtoA,ADDR src2,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                            invoke SetDlgItemText,hDlg,344,ADDR txtbuf
                            invoke FpuFLtoA,ADDR src2.imag,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                            invoke SetDlgItemText,hDlg,345,ADDR txtbuf
                        .endif
                        finit
                    .endif
                .endif
        
                xor   edx,edx
                .if   polar == 1
                    mov   edx,Z_POLAR
                .endif
                push  edx                 ;flags
                push  offset results      ;address for results
          
                .if   funcnum < 308
                    push  offset src2     ;address of scr2 if required
                .endif
                push  offset src1         ;address of scr1
          
                mov   ecx,funcnum
                sub   ecx,302
                call  funcproc[ecx*4]
          
                invoke FpuFLtoA,ADDR results.real,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                invoke SetDlgItemText,hDlg,347,ADDR txtbuf
                invoke FpuFLtoA,ADDR results.imag,15,ADDR txtbuf,SRC1_REAL or SRC2_DIMM
                invoke SetDlgItemText,hDlg,348,ADDR txtbuf
            .endif
        .endif

    .elseif uMsg == WM_CLOSE
        invoke  EndDialog,hDlg,0

    .endif

    return FALSE

inputerr:
    invoke MessageBox,hDlg,ADDR szerror,0,MB_OK
    return FALSE
                
WndProc endp

; ########################################################################

end start

